{-# LANGUAGE TemplateHaskell     #-}


module Phoityne.IO.GUI.VSCode.TH.LaunchRequestArgumentsJSON where

import Data.Aeson.TH

import Phoityne.Utility

-- |
--   Arguments for "launch" request.
--
data LaunchRequestArguments =
  LaunchRequestArguments {
    noDebugLaunchRequestArguments    :: Maybe Bool --  If noDebug is true the launch request should launch the program without enabling debugging.
  , nameLaunchRequestArguments       :: String     -- Phoityne specific argument.
  , typeLaunchRequestArguments       :: String     -- Phoityne specific argument.
  , requestLaunchRequestArguments    :: String     -- Phoityne specific argument. must be "request"
  , startupLaunchRequestArguments    :: String     -- Phoityne specific argument.
  , workspaceLaunchRequestArguments  :: String     -- Phoityne specific argument.
  , logFileLaunchRequestArguments    :: String     -- Phoityne specific argument.
  , logLevelLaunchRequestArguments   :: String     -- Phoityne specific argument.
  , ghciPromptLaunchRequestArguments :: String     -- Phoityne specific argument.
  } deriving (Show, Read, Eq)


$(deriveJSON defaultOptions { fieldLabelModifier = rdrop (length "LaunchRequestArguments") } ''LaunchRequestArguments)

